LBG_BUTTON* LBG_create_button (LBG_WINDOW* _parent, var pos_x, var pos_y, var tpos_x, var tpos_y, STRING* caption, LBG_BUTTON_BMAPS* bmaps, void *Event, long flags)
{
	LBG_BUTTON* but = malloc(sizeof(LBG_BUTTON));
	but->ssize = sizeof(LBG_BUTTON);
	but->stype = 2;
	
	if(flags & BF_EXTERNSTRING)
	{
		but->caption = caption;
	}
	else
	{
		but->caption = str_create("");
		str_cpy(but->caption,caption);
	}
	
	
	but->parent = _parent;
	but->layer = 0;
	but->flags = flags;
	
	but->text = txt_create(1,LBG_object_calc_text_layer(but));
	ptr_remove((but->text->pstring)[0]);
	(but->text->pstring)[0] = but->caption;
	
	but->text->font = LBG_button_font;
	
	but->tpos_x = tpos_x;
	but->tpos_y = tpos_y;
	
	but->tpos_over_x = 0;
	but->tpos_over_y = 0;
	but->tpos_clicked_x = 0;
	but->tpos_clicked_y = 0;
	
	but->color_default.red = 255;
	but->color_default.green = 255;
	but->color_default.blue = 255;
	
	but->color_over.red = 255;
	but->color_over.green = 255;
	but->color_over.blue = 255;
	
	but->color_clicked.red = 255;
	but->color_clicked.green = 255;
	but->color_clicked.blue = 255;
	
	but->color_disabled.red = 255;
	but->color_disabled.green = 255;
	but->color_disabled.blue = 255;
	
	
	
	but->pos_x = pos_x;
	but->pos_y = pos_y;
	
	but->scale_x = 1;
	but->scale_y = 1;
	
	but->panel = pan_create("",LBG_object_calc_panel_layer(but));
	but->bmap_default = bmaps->bmap_default;
	but->bmap_over = bmaps->bmap_over;
	but->bmap_clicked = bmaps->bmap_clicked;
	but->bmap_active = bmaps->bmap_active;
	but->bmap_overactive = bmaps->bmap_overactive;
	but->bmap_disabled = bmaps->bmap_disabled;
	
	but->size_x = bmap_width(but->bmap_default);
	but->size_y = bmap_height(but->bmap_default);
	
	
	but->panel->bmap = but->bmap_default;
	but->panel->pos_x = but->pos_x;
	but->panel->pos_y = but->pos_y;
	but->panel->size_x = but->size_x;
	but->panel->size_y = but->size_y;
	
	but->text->pos_x = but->pos_x + but->tpos_x;
	but->text->pos_y = but->pos_y + but->tpos_y;
	
	if(but->flags & BF_SHOW)
	{
		but->panel->flags |= SHOW;
		but->text->flags |= SHOW;
	}
	
	but->text.size_x = but.size_x;
	
	
	but->next = NULL;
	if(LBG_BUTTON_FIRST == NULL)
	{
		LBG_BUTTON_FIRST = but;
		but->previous = NULL;
	}
	else
	{
		but->previous = LBG_object_last(LBG_BUTTON_FIRST);
		but->previous->next = but;
	}
	
	
	LBG_object_upate_size (but);
	
	but->Destroy = NULL;
	but->Event = Event;
	but->Over = NULL;
	but->Leave = NULL;
	but->Condition = NULL;
	
	
	return (but);
}

void LBG_button_autoalign_text (LBG_BUTTON* but)
{
	but->tpos_x = integer((but->size_x - minv(but->text->size_x,str_width((but->text->pstring)[0],but->text->font)))/2);
	but->text->pos_x = but->pos_x + but->tpos_x;
}


void LBG_button_execute (LBG_BUTTON* but, void* func)
{
	if(func != 0)
	{
		LBG_event_object = but;
		LBG_event_button = but;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_button_condition (LBG_BUTTON* but, void* func)
{
	if(func != 0)
	{
		LBG_event_object = but;
		LBG_event_button = but;
		LBG_condition = func;
		return LBG_condition();
	}
	return 1;
}


void LBG_button_event (LBG_BUTTON* but)
{
	but.flags &= ~BF_EVENT;
	if(!key_pressed(280)) return;
	LBG_HANDLE* h = LBG_get_eventhandle(but);
	wait(1);
	if(!h->valid)
	{
		LBG_destroy_handle(h);
		return;
	}
	if(!key_pressed(280))
	{
		but->flags |= BF_EVENT;
		LBG_button_execute(but,but->Event);
		wait(1);
		if(!h->valid)
		{
			LBG_destroy_handle(h);
			return;
		}
		but->flags &= ~BF_EVENT;
	}
	LBG_destroy_handle(h);
}

LBG_WINDOW* LBG_mouse_window ();
int LBG_button_mouse_window (LBG_BUTTON* but)
{
	if(but->parent) if ((but->parent->stype == 9) || (but->parent->stype == 10))
	{
		if(but->parent->parent) if(but->parent->parent->stype == 13) return (but->parent->parent->parent == LBG_mouse_window());
		return (but->parent->parent == LBG_mouse_window());
	}
	if(but->flags & BFi_COMBOBOX) return (but->parent->parent == LBG_mouse_window());
	return (but->parent == LBG_mouse_window());
}

void LBG_update_button_layer (LBG_BUTTON* but)
{
	var x;
	
	if(but->flags & BFi_SCROLLBAR)
	if(but->parent)
	if(but->parent->parent)
	if(but->parent->parent->stype == 13)
	{
		x = but->parent->panel->layer+1;
		if(but->panel->layer != x) layer_sort(but->panel,x);
		return;
	}
	
	if(but->flags & BFi_COMBOBOX)
	{
		x = ((LBG_COMBOBOX*)(but->parent))->editbox->panel->layer;
		if(but->panel->layer != x) layer_sort(but->panel,x);
		return;
	}
	
	
	
	x = LBG_object_calc_panel_layer(but);
	if(but->panel->layer != x) layer_sort(but->panel,x);
	x = LBG_object_calc_text_layer(but);
	if(but->text->layer != x) layer_sort(but->text,x);
}


int LBG_window_mouse_over_content (LBG_WINDOW* win);
int LBG_button_scrollbar_condition (LBG_BUTTON* but)
{
	if(!but->parent) return 1;
	if((but->parent->stype != 9) && (but->parent->stype != 10)) return 1;
	if(!but->parent->parent) return 1;
	if(but->parent->parent->stype != 13) return 1;
	if(but->parent->parent->parent)
	{
		return LBG_window_mouse_over_content (but->parent->parent->parent);
	}
	return 1;
}


LBG_WINDOW* LBG_button_parent_window (LBG_BUTTON* but)
{
	if(but->flags & BFi_COMBOBOX) return but->parent->parent;
	else return but->parent;
}


LBG_BUTTON* LBG_manage_button (LBG_BUTTON* but)
{
	LBG_object_update_pos(but);
	LBG_object_update_size(but);
	LBG_update_button_layer(but);
	
	vec_set(but->text->blue,but->color_default);
	
	if (!(but->flags & BF_DISABLED))
	{
		
		
		if(LBG_not_disabled_by_disableflag(but) && (!key_space) && (but->flags & BFi_SPACE))
		{
			if (!(but->flags & BFi_BLOCKSPACE)) LBG_button_execute(but,but->Event);
			else but->flags &= ~BFi_BLOCKSPACE;
			but->flags &= ~BFi_SPACE;
		}
		
		if (LBG_not_disabled_by_disableflag(but) && (but->flags & BF_ACTIVE) && (!(but->flags & BF_IGNOREKEYBOARD)) && (!(but->flags & BFi_SPACE)) && key_space && (!((but->flags & BFi_TITLEBAR) || (but->flags & BFi_SCROLLBAR) || (but->flags & BFi_COMBOBOX))))
		{
			but->flags |= BFi_SPACE;
		}
		
		if (LBG_not_disabled_by_disableflag(but) && (but->flags & BF_ACTIVE) && (!(but->flags & BF_IGNOREKEYBOARD)) && (!(but->flags & BFi_ENTER)) && key_enter && (!((but->flags & BFi_TITLEBAR) || (but->flags & BFi_SCROLLBAR) || (but->flags & BFi_COMBOBOX))))
		{
			LBG_button_execute(but,but->Event);
			but->flags |= BFi_ENTER;
			if(key_space) but->flags |= BFi_BLOCKSPACE;
		}
		if(!key_enter) but->flags &= ~BFi_ENTER;
		
		
		
		if (!(key_pressed(280)))
		{
			but->flags &= ~BFi_CLICK0;
			but->flags &= ~BFi_CLICK1;
			but->flags &= ~BF_CLICKED;
		}
		
		if (LBG_not_disabled_by_disableflag(but) && LBG_button_condition(but,but->Condition) && LBG_mouse_over_object(but) && LBG_button_mouse_window(but) && (LBG_window_mouse_over_content (LBG_button_parent_window(but)) || (but->flags & BFi_TITLEBAR) || (but->flags & BFi_SCROLLBAR) || (but->flags & BFi_COMBOBOX)) && LBG_button_scrollbar_condition(but) && (((!(but->flags & BFi_CLICK0)) && (!(but->flags & BFi_CLICK1))) || ((!(but->flags & BFi_CLICK0)) && ((but->flags & BFi_CLICK1)))))
		{
			LBG_mouse_cursor = 1;
			if(!(but->flags & BFi_OVER)) LBG_button_execute(but,but->Over);
			but->flags |= BFi_OVER;
			if(but->flags & BF_ACTIVE) but->panel.bmap = but->bmap_overactive;
			else but->panel.bmap = but->bmap_over;
			but->text->pos_x += but->tpos_over_x;
			but->text->pos_y += but->tpos_over_y;
			vec_set(but->text->blue,but->color_over);
			if (key_pressed(280))
			{
				but->flags &= ~BFi_CLICK0;
				but->flags |= BFi_CLICK1;
				but->flags |= BF_CLICKED;
				but->panel.bmap = but->bmap_clicked;
				but->text->pos_x += but->tpos_clicked_x-but->tpos_over_x;
				but->text->pos_y += but->tpos_clicked_y-but->tpos_over_y;
				vec_set(but->text->blue,but->color_clicked);
				LBG_button_event(but);
				
				if(!((but->flags & BFi_TITLEBAR) || (but->flags & BFi_SCROLLBAR) || (but->flags & BFi_COMBOBOX)))
				but->flags |= BF_ACTIVE;
				
			}
		}
		else
		{
			if(but->flags & BF_ACTIVE) but->panel.bmap = but->bmap_active;
			else but->panel.bmap = but->bmap_default;
			but.flags &= ~BF_EVENT;
			
			if(but->flags & BFi_OVER) LBG_button_execute(but,but->Leave);
			but->flags &= ~BFi_OVER;
			but->flags &= ~BF_CLICKED;
		}
		if ((!(but->flags & BFi_CLICK0)) && (!(but->flags & BFi_CLICK1)) && (key_pressed(280)))
		{
			but->flags |= BFi_CLICK0;
			but->flags &= ~BFi_CLICK1;
			but->flags &= ~BF_CLICKED;
			
			but->flags &= ~BF_ACTIVE;
			but->flags &= ~BFi_SPACE;
		}
		
		
		if ((but->flags & BFi_SPACE) && (!(but->flags & BFi_BLOCKSPACE)))
		{
			but->panel->bmap = but->bmap_clicked;
			but->text->pos_x = but->pos_x + but->tpos_x + but->tpos_clicked_x + LBG_object_ppos_x(but);
			but->text->pos_y = but->pos_y + but->tpos_y + but->tpos_clicked_x + LBG_object_ppos_y(but);
		}
		
	}
	else
	{
		but->flags |= BFi_CLICK0;
		but->flags &= ~BFi_CLICK1;
		but->flags &= ~BFi_OVER;
		but->flags &= ~BF_CLICKED;
		but->panel->bmap = but->bmap_disabled;
		vec_set(but->text->blue,but->color_disabled);
	}
	
	
	
	
	
	
	
	if(but->flags & BF_SHOW)
	{
		but->panel->flags |= SHOW;
		but->text->flags |= SHOW;
	}
	else
	{
		but->panel->flags &= ~SHOW;
		but->text->flags &= ~SHOW;
	}
	
	
	
	return but->next;
}



LBG_BUTTON* LBG_destroy_button (LBG_BUTTON* but)
{
	
	LBG_button_execute(but,but->Destroy);
	
	if(!(but->flags & BF_EXTERNSTRING)) ptr_remove(but->caption);
	ptr_remove(but->text);
	ptr_remove(but->panel);
	
	LBG_object_destroy_infoboxes(but);
	LBG_object_destroy_rightclicks(but);
	
	
	LBG_BUTTON* next = but->next;
	if(but->previous) but->previous->next = but->next;
	else LBG_BUTTON_FIRST = but->next;
	if(but->next) but->next->previous = but->previous;
	
	free(but);
	LBG_object_make_handles_invalid(but);
	return(next);
}












void LBG_bbmaps_destroy_2frames (LBG_BUTTON_BMAPS* bmaps)
{
	wait(2);
	free(bmaps);
}

LBG_BUTTON_BMAPS* LBG_bbmaps (BMAP* bmap_default, BMAP* bmap_over, BMAP* bmap_clicked, BMAP* bmap_active, BMAP* bmap_overactive, BMAP* bmap_disabled)
{
	LBG_BUTTON_BMAPS* bmaps = malloc(sizeof(LBG_BUTTON_BMAPS));
	bmaps->bmap_default = bmap_default;
	bmaps->bmap_over = bmap_over;
	bmaps->bmap_clicked = bmap_clicked;
	bmaps->bmap_active = bmap_active;
	bmaps->bmap_overactive = bmap_overactive;
	bmaps->bmap_disabled = bmap_disabled;
	LBG_bbmaps_destroy_2frames(bmaps);
	return(bmaps);
}



void LBG_update_button (LBG_BUTTON* but)
{
	LBG_object_upate_pos(but);
	LBG_object_upate_size(but);
	LBG_update_button_layer(but);
}