LBG_COMBOBOX* LBG_create_combobox (LBG_WINDOW* _parent, var pos_x, var pos_y, var width,var tpos_x, var tpos_y, STRING* caption, LBG_EDITBOX_BMAPS* ebmaps, var ipos_x, var ipos_y, var isize_x, LBG_LISTBOX_BMAPS* mbmaps, LBG_BUTTON_BMAPS* bbmaps, long flags)
{
	LBG_COMBOBOX* cbb = malloc(sizeof(LBG_COMBOBOX));
	cbb->ssize = sizeof(LBG_COMBOBOX);
	cbb->stype = 16;
	
	
	
	cbb->parent = _parent;
	cbb->layer = 0;
	cbb->flags = flags;
	
	
	cbb->pos_x = pos_x;
	cbb->pos_y = pos_y;
	
	cbb->scale_x = 1;
	cbb->scale_y = 1;
	
	
	
	cbb->menu = LBG_create_listbox (cbb,0,0,width,ipos_y,ipos_x,ipos_y,isize_x,ipos_y,mbmaps,0);
	cbb->menu->flags |= LFi_COMBOBOX;
	
	long eflags = EF_DISABLED;
	if(flags & CBF_EXTERNSTRING) eflags |= EF_EXTERNSTRING;
	cbb->editbox = LBG_create_editbox (cbb->parent,cbb->pos_x,cbb->pos_y,width-bmap_width(bbmaps->bmap_default),tpos_x,tpos_y,caption,ebmaps,eflags);
	cbb->caption = cbb->editbox->caption;
	
	cbb->button = LBG_create_button(cbb,cbb->pos_x+cbb->editbox->size_x,cbb->pos_y,0,0,"",bbmaps,0,BFi_COMBOBOX);
	
	cbb->chosen_option = NULL;
	
	cbb->Destroy = 0;
	cbb->Open = 0;
	cbb->Close = 0;
	
	
	
	if(cbb->flags & CBF_SHOW)
	{
		cbb->editbox->flags |= EF_SHOW;
		cbb->button->flags |= BF_SHOW;
	}
	else
	{
		cbb->editbox->flags &= ~EF_SHOW;
		cbb->menu->flags &= ~LF_SHOW;
		cbb->button->flags &= ~BF_SHOW;
	}
	
	
	cbb->next = NULL;
	if(LBG_COMBOBOX_FIRST == NULL)
	{
		LBG_COMBOBOX_FIRST = cbb;
		cbb->previous = NULL;
	}
	else
	{
		cbb->previous = LBG_object_last(LBG_COMBOBOX_FIRST);
		cbb->previous->next = cbb;
	}
	
	
	
	return (cbb);
}


void LBG_combobox_execute (LBG_COMBOBOX* cbb, void* func)
{
	if(func != 0)
	{
		LBG_event_object = cbb;
		LBG_event_combobox = cbb;
		LBG_event = func;
		LBG_event();
	}
}


LBG_COMBOBOX* LBG_manage_combobox (LBG_COMBOBOX* cbb)
{
	cbb->editbox->pos_x = cbb->pos_x;
	cbb->editbox->pos_y = cbb->pos_y;
	
	if((cbb->menu->flags & LF_SHOW) && (!(LBG_mouse_over_object(cbb->menu))) && ((key_pressed(280)) || (key_pressed(281))))
	{
		cbb->menu->flags &= ~LF_SHOW;
		cbb->menu->flags |= LF_DISABLED;
		LBG_combobox_execute(cbb,cbb->Close);
	}
	
	
	if(cbb->button->flags & BF_EVENT)
	{
		cbb->menu->flags |= LF_SHOW;
		cbb->menu->flags &= ~LF_DISABLED;
		cbb->menu->pos_x = cbb->editbox->panel->pos_x;
		cbb->menu->pos_y = cbb->editbox->panel->pos_y + cbb->editbox->panel->size_y;
		LBG_listbox_calc_size_y(cbb->menu);
		LBG_menu_correct_position(cbb->menu);
		LBG_update_listbox(cbb->menu);
		LBG_combobox_execute(cbb,cbb->Open);
	}
	
	
	
	return cbb->next;
}



void LBG_update_combobox (LBG_COMBOBOX* cbb)
{
	cbb->menu->isize_y = LBG_object_num(cbb->menu->item_first)*cbb->menu->itemheight;
	LBG_update_editbox(cbb->editbox);
	LBG_update_listbox(cbb->menu);
	LBG_update_button(cbb->button);
}


LBG_COMBOBOX* LBG_destroy_combobox (LBG_COMBOBOX* cbb)
{
	
	LBG_combobox_execute(cbb,cbb->Destroy);
	
	LBG_destroy_editbox(cbb->editbox);
	LBG_destroy_button(cbb->button);
	LBG_destroy_listbox(cbb->menu);
	
	LBG_object_destroy_infoboxes(cbb);
	LBG_object_destroy_rightclicks(cbb);
	
	
	LBG_COMBOBOX* next = cbb->next;
	if(cbb->previous) cbb->previous->next = cbb->next;
	else LBG_COMBOBOX_FIRST = cbb->next;
	if(cbb->next) cbb->next->previous = cbb->previous;
	
	
	free(cbb);
	LBG_object_make_handles_invalid(cbb);
	return(next);
}
