
void LBG_editbox_update_vstring (LBG_EDITBOX* ebx)
{
	if(ebx->flags & EF_PASSWORD)
	{
		str_cpy(ebx->vstring,"");
		var n = str_len(ebx->caption)-ebx->hscrollamount;
		var i;
		for(i=0;i<n;i++) str_cat(ebx->vstring,"*");
		return;
	}
	str_cpy(ebx->vstring,ebx->caption);
	str_clip(ebx->vstring,ebx->hscrollamount);
}


LBG_EDITBOX* LBG_create_editbox (LBG_WINDOW* _parent, var pos_x, var pos_y, var width, var tpos_x, var tpos_y, STRING* caption, LBG_EDITBOX_BMAPS* bmaps, long flags)
{
	LBG_EDITBOX* ebx = malloc(sizeof(LBG_EDITBOX));
	ebx->ssize = sizeof(LBG_EDITBOX);
	ebx->stype = 18;
	
	if(flags & EF_EXTERNSTRING)
	{
		ebx->caption = caption;
	}
	else
	{
		ebx->caption = str_create("");
		str_cpy(ebx->caption,caption);
	}
	ebx->vstring = str_create(ebx->caption);
	ebx->vsleft = str_create(ebx->caption);
	ebx->vsright = str_create("");
	
	
	ebx->parent = _parent;
	ebx->layer = 0;
	ebx->flags = flags;
	
	ebx->text = txt_create(1,LBG_object_calc_text_layer(ebx));
	ptr_remove((ebx->text->pstring)[0]);
	(ebx->text->pstring)[0] = ebx->vstring;
	
	ebx->text->font = LBG_editbox_font;
	
	ebx->tpos_x = tpos_x;
	ebx->tpos_y = tpos_y;
	
	
	ebx->pos_x = pos_x;
	ebx->pos_y = pos_y;
	
	ebx->scale_x = 1;
	ebx->scale_y = 1;
	
	ebx->panel = pan_create("",LBG_object_calc_panel_layer(ebx));
	ebx->bmaps.bmap_left = bmaps.bmap_left;
	ebx->bmaps.bmap_middle = bmaps.bmap_middle;
	ebx->bmaps.bmap_right = bmaps.bmap_right;
	
	
	ebx->size_x = width;
	ebx->size_y = bmap_height(ebx->bmaps.bmap_right);
	
	
	ebx->panel->bmap = bmap_createblack(ebx->size_x,ebx->size_y,32);
	LBG_progressbar_bitmap(ebx->panel->bmap,bmaps,ebx->size_x,ebx->size_y);
	ebx->panel->pos_x = ebx->pos_x;
	ebx->panel->pos_y = ebx->pos_y;
	ebx->panel->size_x = ebx->size_x;
	ebx->panel->size_y = ebx->size_y;
	
	ebx->text->pos_x = ebx->pos_x + ebx->tpos_x;
	ebx->text->pos_y = ebx->pos_y + ebx->tpos_y;
	
	
	
	
	ebx->hscrollamount = 0;
	ebx->cursor = txt_create(1,LBG_object_calc_text_layer(ebx)+1);
	str_cpy((ebx->cursor->pstring)[0],"|");
	ebx->cursor->font = ebx->text->font;
	
	
	ebx->time = 0.5;
	ebx->counter = 0;
	
	ebx->max_length = 0;
	
	
	if(ebx->flags & EF_SHOW)
	{
		ebx->panel->flags |= SHOW;
		ebx->text->flags |= SHOW;
		ebx->cursor->flags |= SHOW;
	}
	
	
	
	ebx->next = NULL;
	if(LBG_EDITBOX_FIRST == NULL)
	{
		LBG_EDITBOX_FIRST = ebx;
		ebx->previous = NULL;
	}
	else
	{
		ebx->previous = LBG_object_last(LBG_EDITBOX_FIRST);
		ebx->previous->next = ebx;
	}
	
	
	LBG_object_upate_size (ebx);
	
	
	
	ebx->Destroy = 0;
	ebx->Mask = 0;
	ebx->Key = 0;
	
	
	LBG_editbox_update_vstring(ebx);
	
	return (ebx);
}

void LBG_update_editbox_layer (LBG_EDITBOX* ebx)
{
	var x;
	x = LBG_object_calc_panel_layer(ebx);
	if(ebx->panel->layer != x) layer_sort(ebx->panel,x);
	x = LBG_object_calc_text_layer(ebx);
	if(ebx->text->layer != x) layer_sort(ebx->text,x);
	x = LBG_object_calc_text_layer(ebx)+1;
	if(ebx->cursor->layer != x) layer_sort(ebx->cursor,x);
}


STRING* LBG_str_width_str_temp = "";
var LBG_str_width (STRING* str, FONT* font)
{
	str_cpy(LBG_str_width_str_temp,str);
	var x = str_width("W",font);
	str_cat(LBG_str_width_str_temp,"W");
	var y = str_width(LBG_str_width_str_temp,font);
	return y-x;
}





void LBG_editbox_update_vleftright (LBG_EDITBOX* ebx)
{
	str_cpy(ebx->vsleft,ebx->vstring);
	str_cpy(ebx->vsright,ebx->vstring);
	str_trunc(ebx->vsleft,str_len(ebx->vstring)-ebx->cursor_pos+ebx->hscrollamount);
	str_clip(ebx->vsright,str_len(ebx->vstring)-ebx->cursor_pos+ebx->hscrollamount);
	
}

void LBG_editbox_update_cursor_pos (LBG_EDITBOX* ebx)
{
	ebx->cursor->pos_x = ebx->text->pos_x + LBG_str_width(ebx->vsleft,ebx->text->font) -str_width("|",ebx->text->font)/2;
	ebx->cursor->pos_y = ebx->text->pos_y;
}

void LBG_editbox_update_cursor(LBG_EDITBOX* ebx)
{
	if(ebx->cursor_pos < 0) ebx->cursor_pos = 0;
	if(ebx->cursor_pos > str_len(ebx->caption)) ebx->cursor_pos = str_len(ebx->caption);
	
	
	LBG_editbox_update_vstring(ebx);
	LBG_editbox_update_vleftright(ebx);
	LBG_editbox_update_cursor_pos(ebx);
}


STRING* LBG_editbox_inchar_str1 = "";
STRING* LBG_editbox_inchar_str2 = "";


void LBG_editbox_backspace(LBG_EDITBOX* ebx)
{
	if(ebx->cursor_pos <= 0) return;
	str_cpy(ebx->vsleft,ebx->caption);
	str_cpy(ebx->vsright,ebx->caption);
	str_trunc(ebx->vsleft,str_len(ebx->caption)-ebx->cursor_pos+1);
	str_clip(ebx->vsright,ebx->cursor_pos);
	str_cpy(ebx->caption,ebx->vsleft);
	str_cat(ebx->caption,ebx->vsright);
	ebx->cursor_pos--;
	str_cpy(LBG_editbox_inchar_str1,"");
	
	
	LBG_editbox_update_cursor(ebx);
}

void LBG_editbox_delete(LBG_EDITBOX* ebx)
{
	if(ebx->cursor_pos >= str_len(ebx->caption)) return;
	str_cpy(ebx->vsleft,ebx->caption);
	str_cpy(ebx->vsright,ebx->caption);
	str_trunc(ebx->vsleft,str_len(ebx->caption)-ebx->cursor_pos);
	str_clip(ebx->vsright,ebx->cursor_pos+1);
	str_cpy(ebx->caption,ebx->vsleft);
	str_cat(ebx->caption,ebx->vsright);
	str_cpy(LBG_editbox_inchar_str1,"");
	
	
	LBG_editbox_update_cursor(ebx);
}


void LBG_editbox_autoscroll_right (LBG_EDITBOX* ebx)
{
	while(ebx->cursor->pos_x > ebx->text->pos_x + bmap_width(ebx->panel->bmap)-ebx->tpos_x*2)
	{
		ebx->hscrollamount++;
		if(ebx->hscrollamount >= str_len(ebx->caption))
		{
			ebx->hscrollamount = str_len(ebx->caption);
			LBG_editbox_update_cursor(ebx);
			break;
		}
		LBG_editbox_update_cursor(ebx);
	}
}

void LBG_editbox_autoscroll_left (LBG_EDITBOX* ebx)
{
	while(ebx->cursor_pos < ebx->hscrollamount)
	{
		ebx->hscrollamount-=5;
		if(ebx->hscrollamount <= 0)
		{
			ebx->hscrollamount = 0;
			LBG_editbox_update_cursor(ebx);
			break;
		}
		LBG_editbox_update_cursor(ebx);
	}
}

void LBG_editbox_autoscroll (LBG_EDITBOX* ebx)
{
	LBG_editbox_autoscroll_left(ebx);
	LBG_editbox_autoscroll_right(ebx);
}




void LBG_editbox_execute (LBG_EDITBOX* ebx, void* func)
{
	if(func != 0)
	{
		LBG_event_object = ebx;
		LBG_event_editbox = ebx;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_mask (STRING* input);
int LBG_editbox_mask (LBG_EDITBOX* ebx, void* func, STRING* input)
{
	if(func != 0)
	{
		LBG_event_object = ebx;
		LBG_event_editbox = ebx;
		LBG_mask = func;
		return LBG_mask(input);
	}
	return 1;
}



LBG_EDITBOX* LBG_active_editbox;
void LBG_find_active_editbox ()
{
	LBG_active_editbox = NULL;
	LBG_EDITBOX* ebx = LBG_EDITBOX_FIRST;
	while(ebx)
	{
		if(ebx->flags & EF_ACTIVE)
		{
			LBG_active_editbox = ebx;
			return;
		}
		ebx = ebx->next;
	}
}



void LBG_editbox_inchar_loop ()
{
	while(1)
	{
		LBG_find_active_editbox();
		if(!LBG_active_editbox)
		{
			wait(1);
			if(!(LBG_flags & LBGUI_RUNNING)) return;
			continue;
		}
		if(LBG_active_editbox->flags & EF_ACTIVE)
		{
			inchar(LBG_editbox_inchar_str2);
		}
		else wait(1);
		if(!(LBG_flags & LBGUI_RUNNING)) return;
		LBG_find_active_editbox();
		if(!LBG_active_editbox) continue;
		if(str_to_asc(LBG_editbox_inchar_str2) == 32)
		{
			LBG_active_editbox->counter = 0;
			LBG_flags &= ~LBGUI_STOPACTION;
			if(key_lastpressed != 57)
			{
				str_cpy(LBG_editbox_inchar_str2,""); // if it's not a space, it shouldn't return a space!
				LBG_editbox_execute(LBG_active_editbox,LBG_active_editbox->Key);
			}
			if(!(LBG_flags & LBGUI_STOPACTION))
			switch(key_lastpressed)
			{
				case 75: // left
				LBG_active_editbox->cursor_pos--;
				LBG_editbox_update_cursor(LBG_active_editbox);
				break;
				case 77: // right
				LBG_active_editbox->cursor_pos++;
				LBG_editbox_update_cursor(LBG_active_editbox);
				break;
				case 14: // backspace
				LBG_editbox_backspace(LBG_active_editbox);
				break;
				case 83: // delete
				LBG_editbox_delete(LBG_active_editbox);
				break;
				case 71: // Home (Pos1)
				LBG_active_editbox->cursor_pos=0;
				LBG_editbox_update_cursor(LBG_active_editbox);
				break;
				case 79: // End
				LBG_active_editbox->cursor_pos=str_len(LBG_active_editbox->caption);
				LBG_editbox_update_cursor(LBG_active_editbox);
				break;
			}
			LBG_editbox_autoscroll(LBG_active_editbox);
		}
		if(LBG_active_editbox->flags & EF_NUMBERS)
		{
			var c = str_to_asc(LBG_editbox_inchar_str2);
			if ((c < 48) || (c > 57)) str_cpy(LBG_editbox_inchar_str2,"");
		}
		if(LBG_active_editbox->flags & EF_ALPHANUMERIC)
		{
			var c = str_to_asc(LBG_editbox_inchar_str2);
			if (((c < 48) || (c > 57)) && ((c < 97) || (c > 122)) && ((c < 65) || (c > 90)) && (c != 95) && (c != 32)) str_cpy(LBG_editbox_inchar_str2,"");
		}
		if(LBG_active_editbox->flags & EF_NOSPACE)
		{
			if(str_to_asc(LBG_editbox_inchar_str2) == 32) str_cpy(LBG_editbox_inchar_str2,"");
		}
		if(LBG_active_editbox->flags & EF_NOUNDERSCORE)
		{
			if(str_to_asc(LBG_editbox_inchar_str2) == 95) str_cpy(LBG_editbox_inchar_str2,"");
		}
		if(!LBG_editbox_mask(LBG_active_editbox,LBG_active_editbox->Mask,LBG_editbox_inchar_str2)) str_cpy(LBG_editbox_inchar_str2,"");
		
		if (LBG_active_editbox->max_length) if(str_len(LBG_active_editbox->caption) >= LBG_active_editbox->max_length) str_cpy(LBG_editbox_inchar_str2,"");
		
		if ((key_lastpressed == 28) || (key_lastpressed == 1))
		{
			LBG_active_editbox->flags &= ~EF_ACTIVE;
			LBG_find_active_editbox();
			str_cpy(LBG_editbox_inchar_str1,"");
			str_cpy(LBG_editbox_inchar_str2,"");
			continue;
		}
		
		
		
		str_cat(LBG_editbox_inchar_str1,LBG_editbox_inchar_str2);
		str_cpy(LBG_editbox_inchar_str2,"");
		if(LBG_active_editbox->flags & EF_READONLY) str_cpy(LBG_editbox_inchar_str1,"");
	}
	
}



void LBG_editbox_add_input(LBG_EDITBOX* ebx)
{
	if(!str_len(LBG_editbox_inchar_str1)) return;
	ebx->counter = 0;
	
	str_cpy(ebx->vsleft,ebx->caption);
	str_cpy(ebx->vsright,ebx->caption);
	str_trunc(ebx->vsleft,str_len(ebx->caption)-ebx->cursor_pos);
	str_clip(ebx->vsright,ebx->cursor_pos);
	str_cpy(ebx->caption,ebx->vsleft);
	str_cat(ebx->caption,LBG_editbox_inchar_str1);
	str_cat(ebx->caption,ebx->vsright);
	ebx->cursor_pos += str_len(LBG_editbox_inchar_str1);
	str_cpy(LBG_editbox_inchar_str1,"");
	
	
	LBG_editbox_update_cursor(ebx);
	LBG_editbox_autoscroll(ebx);
}


void LBG_editbox_set_cursor_pos_by_mouse (LBG_EDITBOX* ebx)
{
	var x = str_width("|",ebx->text->font)/2;
	if(mouse_pos.x - x <= ebx->text->pos_x)
	{
		ebx->cursor_pos = ebx->hscrollamount;
		LBG_editbox_update_cursor(ebx);
		return;
	}
	if(mouse_pos.x - x >= LBG_str_width(ebx->vstring,ebx->text->font) + ebx->text->pos_x)
	{
		ebx->cursor_pos = str_len(ebx->vstring) + ebx->hscrollamount;
		LBG_editbox_update_cursor(ebx);
		return;
	}
	var i; var y = str_len(ebx->vstring);
	for(i=1;i<=y;i++)
	{
		str_cpy(LBG_str_temp,ebx->vstring);
		str_trunc(LBG_str_temp,y-i);
		if(mouse_pos.x - x <= ebx->text->pos_x + LBG_str_width(LBG_str_temp,ebx->text->font))
		{
			ebx->cursor_pos = i + ebx->hscrollamount;
			LBG_editbox_update_cursor(ebx);
			return;
		}
	}
	ebx->cursor_pos = str_len(ebx->vstring) + ebx->hscrollamount;
	LBG_editbox_update_cursor(ebx);
	
}



LBG_EDITBOX* LBG_manage_editbox (LBG_EDITBOX* ebx)
{
	LBG_object_upate_pos(ebx);
	LBG_object_upate_size(ebx);
	LBG_update_editbox_layer(ebx);
	ebx->cursor->pos_y = ebx->text->pos_y;
	
	ebx->counter += time_step/16;
	ebx->counter %= (ebx->time*2);
	
	if (!(ebx->flags & EF_DISABLED))
	{
		if (!(key_pressed(280)))
		{
			ebx->flags &= ~EFi_CLICK0;
			ebx->flags &= ~EFi_CLICK1;
			ebx->flags &= ~EF_CLICKED;
		}
		
		if (LBG_mouse_over_object(ebx) && (ebx->parent == LBG_mouse_window()) && LBG_window_mouse_over_content (ebx->parent) && (((!(ebx->flags & EFi_CLICK0)) && (!(ebx->flags & EFi_CLICK1))) || ((!(ebx->flags & EFi_CLICK0)) && ((ebx->flags & EFi_CLICK1)))))
		{
			LBG_mouse_cursor = 6;
			
			
			ebx->flags |= EFi_OVER;
			if (key_pressed(280))
			{
				ebx->flags &= ~EFi_CLICK0;
				ebx->flags |= EFi_CLICK1;
				ebx->flags |= EF_CLICKED;
				
				ebx->flags |= EF_ACTIVE;
				inkey_active = 0;
				LBG_editbox_set_cursor_pos_by_mouse(ebx);
				ebx->counter = 0;
			}
		}
		else
		{
			ebx.flags &= ~EF_EVENT;
			ebx->flags &= ~EFi_OVER;
			ebx->flags &= ~EF_CLICKED;
		}
		if ((!(ebx->flags & EFi_CLICK0)) && (!(ebx->flags & EFi_CLICK1)) && (key_pressed(280)))
		{
			ebx->flags |= EFi_CLICK0;
			ebx->flags &= ~EFi_CLICK1;
			ebx->flags &= ~EF_CLICKED;
			
			ebx->flags &= ~EF_ACTIVE;
		}
		
	}
	else
	{
		ebx->flags |= EFi_CLICK0;
		ebx->flags &= ~EFi_CLICK1;
		ebx->flags &= ~EFi_OVER;
		ebx->flags &= ~EF_CLICKED;
	}
	
	
	
	if(LBG_active_editbox == ebx) LBG_editbox_add_input(ebx);
	if (ebx->max_length) if(str_len(ebx->caption) > ebx->max_length)
	{
		str_trunc(ebx->caption,str_len(ebx->caption)-ebx->max_length);
		LBG_editbox_update_cursor(ebx);
	}
	
	
	
	if(ebx->flags & EF_SHOW)
	{
		ebx->panel->flags |= SHOW;
		ebx->text->flags |= SHOW;
		if(ebx->counter < ebx->time) ebx->cursor->flags |= SHOW;
		else ebx->cursor->flags &= ~SHOW;
		if(!(ebx->flags & EF_ACTIVE)) ebx->cursor->flags &= ~SHOW;
	}
	else
	{
		ebx->panel->flags &= ~SHOW;
		ebx->text->flags &= ~SHOW;
		ebx->cursor->flags &= ~SHOW;
	}
	
	
	
	
	
	
	
	return ebx->next;
}







LBG_EDITBOX* LBG_destroy_editbox (LBG_EDITBOX* ebx)
{
	
	LBG_editbox_execute(ebx,ebx->Destroy);
	
	if(!(ebx->flags & EF_EXTERNSTRING)) ptr_remove(ebx->caption);
	ptr_remove(ebx->text);
	ptr_remove(ebx->panel);
	ptr_remove(ebx->vstring);
	ptr_remove(ebx->vsleft);
	ptr_remove(ebx->vsright);
	ptr_remove(ebx->cursor);
	
	LBG_object_destroy_infoboxes(ebx);
	LBG_object_destroy_rightclicks(ebx);
	
	LBG_EDITBOX* next = ebx->next;
	if(ebx->previous) ebx->previous->next = ebx->next;
	else LBG_EDITBOX_FIRST = ebx->next;
	if(ebx->next) ebx->next->previous = ebx->previous;
	
	
	free(ebx);
	LBG_object_make_handles_invalid(ebx);
	return(next);
}




void LBG_update_editbox (LBG_EDITBOX* ebx)
{
	LBG_object_upate_pos(ebx);
	LBG_object_upate_size(ebx);
	LBG_update_editbox_layer(ebx);
	LBG_editbox_update_cursor(ebx);
	LBG_editbox_autoscroll(ebx);
	ptr_remove(ebx->panel->bmap);
	ebx->panel->bmap = bmap_createblack(ebx->size_x,ebx->size_y,32);
	LBG_progressbar_bitmap(ebx->panel->bmap,ebx->bmaps,ebx->size_x,ebx->size_y);
}




void LBG_ebmaps_destroy_2frames (LBG_EDITBOX_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_EDITBOX_BMAPS* LBG_ebmaps (BMAP* bmap_left, BMAP* bmap_middle, BMAP* bmap_right)
{
	LBG_EDITBOX_BMAPS* bmaps = malloc(sizeof(LBG_EDITBOX_BMAPS));
	bmaps->bmap_left = bmap_left;
	bmaps->bmap_middle = bmap_middle;
	bmaps->bmap_right = bmap_right;
	LBG_ebmaps_destroy_2frames(bmaps);
	return(bmaps);
}



void LBG_editbox_set_text_color (LBG_EDITBOX* ebx, COLOR* color)
{
	vec_set(ebx->text->blue,color);
	vec_set(ebx->cursor->blue,color);
}