
// Window flags
#define WF_DISABLED		(1<<1)
#define WFi_NOTITLEBAR	(1<<2)
#define WFi_NOBORDER		(1<<3)
#define WF_XBUTTON		(1<<4)
#define WF_MAXBUTTON		(1<<5)

#define WF_RESIZEABLE	(1<<7)
#define WF_RESIZABLE	WF_RESIZEABLE
#define WF_MAXIMIZED		(1<<8)
#define WF_EXTERNSTRING	(1<<9) // Caption string not recreated, but pointer taken from parameter
#define WF_DONTDESTROY	(1<<10)
#define WF_DONTDESTROYCHILDS (1<<11) // Don't destroy any child when destroyed

#define WF_SHOW			(1<<14) // wie SHOW

#define WF_HSCROLLBAR	(1<<19) // horizontal scrollbar
#define WF_VSCROLLBAR	(1<<20) // vertical scrollbar
#define WF_AUTOHSCROLL	(1<<21) // create and destroy scrollbar when necessary
#define WF_AUTOVSCROLL	(1<<22)

#define WF_DONTSETTOTOP	(1<<25) // Don't set window to top when klicked on (e.g. if it's a background fullscreen window)
#define WF_DONTMOVE		(1<<26) // Can't move the window
#define WF_STAYONTOP		(1<<27) // Always stay on top
#define WF_DISABLEPARENT		(1<<28) // Like a dialog box or a MessageBox. Disables the parent window.
#define WF_DISABLEGUI		(1<<29) // Like a dialog box or a MessageBox. Disabled everything else.
#define WF_LOCKSIZE_X	(1<<30) // Can't be scaled horizontally
#define WF_LOCKSIZE_Y	(1<<31) // Can't be scaled vertically

#define WF2i_LYCLICK0	(1<<0)
#define WF2i_LYCLICK1	(1<<1)
#define WF2i_LYOVER		(1<<2)
#define WF2i_BTCLICK0	(1<<3)
#define WF2i_BTCLICK1	(1<<4)
#define WF2i_BTOVER		(1<<5)
#define WF2i_BLCLICK0	(1<<6)
#define WF2i_BLCLICK1	(1<<7)
#define WF2i_BLOVER		(1<<8)
#define WF2i_BRCLICK0	(1<<9)
#define WF2i_BRCLICK1	(1<<10)
#define WF2i_BROVER		(1<<11)
#define WF2i_BBCLICK0	(1<<12)
#define WF2i_BBCLICK1	(1<<13)
#define WF2i_BBOVER		(1<<14)
#define WF2i_CLICK0		(1<<15)
#define WF2i_CLICK1		(1<<16)
#define WF2i_OVER			(1<<17)
#define WF2i_ASETTOTOP	(1<<18) // already set to top


// Button flags
#define BF_ACTIVE		(1<<0)
#define BF_DISABLED	(1<<1)
#define BF_IGNOREKEYBOARD	(1<<2)

#define BFi_TITLEBAR	(1<<4) // an X, max, min or restore button
#define BFi_SCROLLBAR	(1<<5) // scrollbar button
#define BFi_ENTER		(1<<6) // enter button pressed, don't trigger event again
#define BFi_SPACE		(1<<7) // enter button pressed, don't trigger event again
#define BFi_BLOCKSPACE		(1<<8) // don't trigger event with space after if was triggered with enter
#define BF_EXTERNSTRING	(1<<9) // Caption string not recreated, but pointer taken from parameter
#define BF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed
#define BFi_COMBOBOX (1<<11) // Button of a combobox

#define BF_SHOW		(1<<14) // wie SHOW

#define BF_EVENT		(1<<27)
#define BF_CLICKED	(1<<28)
#define BFi_CLICK0	(1<<29)
#define BFi_CLICK1	(1<<30)
#define BFi_OVER		(1<<31)




// Panel flags
#define PF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed
#define PF_DONTDESTROYPANEL (1<<11) // Don't destroy panel when the object is destroyed
#define PF_HIDE		 (1<<12) // Hide panel when object is destroyed

#define PF_SHOW		(1<<14) // wie SHOW




// Text flags
#define TF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed
#define TF_DONTDESTROYTEXT (1<<11) // Don't destroy text when the object is destroyed
#define TF_HIDE		 (1<<12) // Hide panel when object is destroyed

#define TF_SHOW		(1<<14) // wie SHOW



// Checkbox flags
#define CF_DISABLED	(1<<1)


#define CF_EXTERNSTRING	(1<<9) // Caption string not recreated, but pointer taken from parameter

#define CF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed


#define CF_SHOW		(1<<14) // wie SHOW


#define CF_RADIO		(1<<25) // The checkbox is a radiobutton
#define CF_CHECKED	(1<<26)
#define CF_EVENT		(1<<27)
#define CF_CLICKED	(1<<28)
#define CFi_CLICK0	(1<<29)
#define CFi_CLICK1	(1<<30)
#define CFi_OVER		(1<<31)




// Infobox flags
#define IF_DISABLED	(1<<1)


#define IF_EXTERNSTRING	(1<<9) // Caption string not recreated, but pointer taken from parameter

#define IF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed


#define IF_SHOW		(1<<14) // wie SHOW

#define IF_SHOWING	(1<<31) // wenn es gerade sichbar ist




// Progress bar flags
#define PBF_EXTERNFORMAT	(1<<9) // Caption string not recreated, but pointer taken from parameter

#define PBF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed


#define PBF_SHOW		(1<<14) // wie SHOW

#define PBF_SCALE		(1<<31)




// Horizontal scrollbar flags
#define HSF_DISABLED	(1<<1)

#define HSF_SHOW		(1<<14) // wie SHOW

#define HSF_AUTODISABLED	(1<<21) // Disabled by WF_AUTOHSCROLL (not used anymore!)

#define HSF_CORNER	(1<<25) // show corner

#define HSFi_CLICK0		(1<<29)
#define HSFi_CLICK1		(1<<30)
#define HSFi_OVER			(1<<31)



// Vertical scrollbar flags
#define VSF_DISABLED	(1<<1)

#define VSF_SHOW		(1<<14) // wie SHOW

#define VSF_AUTODISABLED	(1<<21) // Disabled by WF_AUTOVSCROLL (not used anymore!)

#define VSF_CORNER	(1<<25) // show corner

#define VSFi_CLICK0		(1<<29)
#define VSFi_CLICK1		(1<<30)
#define VSFi_OVER			(1<<31)



// Slider flags
#define SF_DISABLED	(1<<1)


#define SF_EXTERNVAR	(1<<8)

#define SF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed


#define SF_SHOW		(1<<14) // wie SHOW


#define SFi_CLICK0		(1<<29)
#define SFi_CLICK1		(1<<30)
#define SFi_OVER			(1<<31)



// Listbox flags
#define LF_DISABLED	(1<<1)
#define LF_MULTIPLE	(1<<2) // enables multiple selection
#define LF_UNSELECT	(1<<3) // enables unselecting
#define LFi_RIGHTCLICK	(1<<4) // rightclick menu

#define LF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed
#define LFi_COMBOBOX		(1<<11) // part of a combobox

#define LF_SHOW		(1<<14) // wie SHOW

#define LF_VSCROLLBAR	(1<<20) // vertical scrollbar

#define LF_AUTOVSCROLL	(1<<22)


// List item flags
#define LIF_EXTERNSTRING	(1<<9) // Caption string not recreated, but pointer taken from parameter

#define LIF_SHOW		(1<<14) // wie SHOW

#define LIF_MARKED	(1<<26)

#define LIF_EVENT		(1<<27)
#define LIF_CLICKED	(1<<28)
#define LIFi_CLICK0		(1<<29)
#define LIFi_CLICK1		(1<<30)
#define LIFi_OVER			(1<<31)


// Rightclick menu flags
#define RF_ACTIVE	(1<<0)
#define RF_DISABLED	(1<<1)

#define RF_SHOW		(1<<14) // wie SHOW

#define RF_EVENT		(1<<27)
#define RF_CLICKED	(1<<28)
#define RFi_CLICK0		(1<<29)
#define RFi_CLICK1		(1<<30)
#define RFi_OVER			(1<<31)


// Combobox flags
#define CBF_DISABLED	(1<<1)

#define CBF_EXTERNSTRING	(1<<9)
#define CBF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed

#define CBF_SHOW		(1<<14) // wie SHOW




// Digits flags
#define DF_EXTERNVAR		(1<<8)
#define DF_EXTERNFORMAT	(1<<9)
#define DF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed

#define DF_SHOW		(1<<14) // wie SHOW




// Editbox flags
#define EF_ACTIVE	(1<<0)
#define EF_DISABLED	(1<<1)
#define EF_READONLY	(1<<2)

#define EF_PASSWORD	(1<<4)
#define EF_NUMBERS	(1<<5)
#define EF_ALPHANUMERIC	(1<<6)
#define EF_NOSPACE	(1<<7)
#define EF_NOUNDERSCORE	(1<<8)
#define EF_EXTERNSTRING	(1<<9)
#define EF_DONTDESTROY (1<<10) // Don't destroy when parent is destroyed

#define EF_SHOW		(1<<14) // wie SHOW

#define EF_EVENT		(1<<27)
#define EF_CLICKED	(1<<28)
#define EFi_CLICK0		(1<<29)
#define EFi_CLICK1		(1<<30)
#define EFi_OVER			(1<<31)






long LBG_flags = 0;

#define LBGUI_RUNNING		(1<<0)
#define LBGUI_DISABLED		(1<<1)
#define LBGUI_PROTECTMOUSE	(1<<2)
#define LBGUI_STOPACTION	(1<<3)