
void LBG_window_content_bitmap (BMAP* _bmap, LBG_CBORDER_BMAPS* bmaps, var size_x, var size_y);

LBG_INFOBOX* LBG_create_infobox (LBG_WINDOW* _target, var time, var pos_x, var pos_y, var tpos_x, var tpos_y, STRING* caption, LBG_CBORDER_BMAPS* bmaps, long flags)
{
	LBG_INFOBOX* ifo = malloc(sizeof(LBG_INFOBOX));
	ifo->ssize = sizeof(LBG_INFOBOX);
	ifo->stype = 7;
	
	if(flags & IF_EXTERNSTRING)
	{
		ifo->caption = caption;
	}
	else
	{
		ifo->caption = str_create("");
		str_cpy(ifo->caption,caption);
	}
	
	
	ifo->target = _target;
	ifo->layer = 0;
	ifo->flags = flags;
	
	ifo->text = txt_create(1,LBG_object_calc_text_layer(ifo));
	ptr_remove((ifo->text->pstring)[0]);
	(ifo->text->pstring)[0] = ifo->caption;
	
	ifo->text->font = LBG_infobox_font;
	
	ifo->tpos_x = tpos_x;
	ifo->tpos_y = tpos_y;
	
	ifo->pos_x = pos_x;
	ifo->pos_y = pos_y;
	
	
	
	ifo->scale_x = 1;
	ifo->scale_y = 1;
	
	
	ifo->bmaps.bmap_topleft = bmaps->bmap_topleft;
	ifo->bmaps.bmap_top = bmaps->bmap_top;
	ifo->bmaps.bmap_topright = bmaps->bmap_topright;
	ifo->bmaps.bmap_left = bmaps->bmap_left;
	ifo->bmaps.bmap_right = bmaps->bmap_right;
	ifo->bmaps.bmap_bottomleft = bmaps->bmap_bottomleft;
	ifo->bmaps.bmap_bottom = bmaps->bmap_bottom;
	ifo->bmaps.bmap_bottomright = bmaps->bmap_bottomright;
	ifo->bmaps.bmap_center = bmaps->bmap_center;
	
	
	
	ifo->panel = pan_create("",LBG_object_calc_panel_layer(ifo));
	ifo->panel->bmap = bmap_createblack(str_width(ifo->caption,ifo->text->font) + ifo->tpos_x*2,ifo->text->font->dy + ifo->tpos_y*2,32);
	LBG_window_content_bitmap(ifo->panel->bmap,bmaps,bmap_width(ifo->panel->bmap),bmap_height(ifo->panel->bmap));
	
	
	
	ifo->minsize_x = 0;
	ifo->minsize_y = 0;
	
	ifo->time = time;
	ifo->counter = 0;
	
	ifo->next = NULL;
	if(LBG_INFOBOX_FIRST == NULL)
	{
		LBG_INFOBOX_FIRST = ifo;
		ifo->previous = NULL;
	}
	else
	{
		ifo->previous = LBG_object_last(LBG_INFOBOX_FIRST);
		ifo->previous->next = ifo;
	}
	
	ifo->Destroy = 0;
	ifo->Appear = 0;
	ifo->Disappear = 0;
	ifo->Condition = 0;
	
	
	LBG_object_upate_size (ifo);
	
	
	return (ifo);
}



void LBG_update_infobox_layer (LBG_INFOBOX* ifo)
{
	var x;
	x = LBG_highest_layer-1;
	if(ifo->panel->layer != x) layer_sort(ifo->panel,x);
	x = LBG_highest_layer;
	if(ifo->text->layer != x) layer_sort(ifo->text,x);
}


void LBG_infobox_execute (LBG_INFOBOX* ifo, void* func)
{
	if(func != 0)
	{
		LBG_event_object = ifo;
		LBG_event_infobox = ifo;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_infobox_condition (LBG_INFOBOX* ifo, void* func)
{
	if(func != 0)
	{
		LBG_event_object = ifo;
		LBG_event_infobox = ifo;
		LBG_condition = func;
		return LBG_condition();
	}
	return 1;
}


LBG_INFOBOX* LBG_manage_infobox (LBG_INFOBOX* ifo)
{
	if(ifo->target) if(LBG_not_disabled_by_disableflag(ifo) && (!(ifo->flags & IF_DISABLED)) && LBG_infobox_condition(ifo,ifo->Condition) && LBG_mouse_over_object(ifo->target) && (ifo->target->parent == LBG_mouse_window()) && LBG_window_mouse_over_content (ifo->target->parent) && LBG_mouse_didnt_move && (!key_pressed(280)) && (!key_pressed(281)) && (!key_pressed(282)) && ((ifo->target->stype != 2) || ((ifo->target->flags & BFi_OVER))))
	{
		if(ifo->counter != -1) ifo->counter += time_step/16;
		if(ifo->counter >= ifo->time)
		{
			ifo->flags |= IF_SHOWING;
			LBG_infobox_execute(ifo,ifo->Appear);
			ifo->counter = -1;
			ptr_remove(ifo->panel->bmap);
			ifo->panel->bmap = bmap_createblack(maxv(str_width(ifo->caption,ifo->text->font) + ifo->tpos_x*2,ifo->minsize_x),maxv(ifo->text->font->dy*LBG_str_num_lines(ifo->caption) + ifo->tpos_y*2,ifo->minsize_y),32);
			ifo->panel->size_x = bmap_width(ifo->panel->bmap);
			ifo->panel->size_y = bmap_height(ifo->panel->bmap);
			LBG_window_content_bitmap(ifo->panel->bmap,ifo->bmaps,bmap_width(ifo->panel->bmap),bmap_height(ifo->panel->bmap));
			if(ifo->flags & IF_SHOW)
			{
				ifo->panel->flags |= SHOW;
				ifo->text->flags |= SHOW;
			}
			ifo->panel->pos_x = mouse_pos.x + ifo->pos_x;
			ifo->panel->pos_y = mouse_pos.y + ifo->pos_y;
			
			if(ifo->panel->pos_x < LBG_screenpos_x) ifo->panel->pos_x = 0;
			else if(ifo->panel->pos_x > LBG_screenpos_x + LBG_screensize_x - ifo->panel->size_x) ifo->panel->pos_x = LBG_screenpos_x + LBG_screensize_x - ifo->panel->size_x;
			if(ifo->panel->pos_y < LBG_screenpos_y) ifo->panel->pos_y = 0;
			else if(ifo->panel->pos_y > LBG_screenpos_y + LBG_screensize_y - ifo->panel->size_y) ifo->panel->pos_y = LBG_screenpos_y + LBG_screensize_y - ifo->panel->size_y;
			
			
			ifo->text->pos_x = ifo->panel->pos_x + ifo->tpos_x;
			ifo->text->pos_y = ifo->panel->pos_y + ifo->tpos_y;
			LBG_update_infobox_layer(ifo);
		}
	}
	else
	{
		ifo->counter = 0;
		ifo->panel->flags &= ~SHOW;
		ifo->text->flags &= ~SHOW;
		if(ifo->flags & IF_SHOWING)
		{
			LBG_infobox_execute(ifo,ifo->Disappear);
		}
		ifo->flags &= ~IF_SHOWING;
	}
	else
	{
		ifo->counter = 0;
		ifo->panel->flags &= ~SHOW;
		ifo->text->flags &= ~SHOW;
		if(ifo->flags & IF_SHOWING)
		{
			LBG_infobox_execute(ifo,ifo->Disappear);
		}
		ifo->flags &= ~IF_SHOWING;
	}
	
	return ifo->next;
}





LBG_INFOBOX* LBG_destroy_infobox (LBG_INFOBOX* ifo)
{
	LBG_infobox_execute(ifo,ifo->Destroy);
	if(!(ifo->flags & IF_EXTERNSTRING)) ptr_remove(ifo->caption);
	ptr_remove(ifo->text);
	ptr_remove(ifo->panel);
	
	LBG_INFOBOX* next = ifo->next;
	if(ifo->previous) ifo->previous->next = ifo->next;
	else LBG_INFOBOX_FIRST = ifo->next;
	if(ifo->next) ifo->next->previous = ifo->previous;
	
	free(ifo);
	LBG_object_make_handles_invalid(ifo);
	return(next);
}
