LBG_PANEL* LBG_create_panel (LBG_WINDOW* _parent, var pos_x, var pos_y, PANEL* panel, long flags)
{
	LBG_PANEL* pan = malloc(sizeof(LBG_PANEL));
	pan->ssize = sizeof(LBG_PANEL);
	pan->stype = 3;
	
	pan->parent = _parent;
	pan->layer = 0;
	pan->flags = flags;
	
	
	pan->pos_x = pos_x;
	pan->pos_y = pos_y;
	
	pan->scale_x = 1;
	pan->scale_y = 1;
	
	pan->panel = panel;
	
	pan->size_x = pan->panel->size_x;
	pan->size_y = pan->panel->size_y;
	
	
	pan->panel->pos_x = pan->pos_x;
	pan->panel->pos_y = pan->pos_y;
	
	if(pan->flags & PF_SHOW)
	{
		if(pan->panel) pan->panel.flags |= SHOW;
	}
	
	
	
	pan->Destroy = 0;
	
	pan->next = NULL;
	if(LBG_PANEL_FIRST == NULL)
	{
		LBG_PANEL_FIRST = pan;
		pan->previous = NULL;
	}
	else
	{
		pan->previous = LBG_object_last(LBG_PANEL_FIRST);
		pan->previous->next = pan;
	}
	
	return (pan);
}




void LBG_update_panel_layer (LBG_PANEL* pan)
{
	var x;
	x = LBG_object_calc_panel_layer(pan);
	if(pan->panel->layer != x) layer_sort(pan->panel,x);
}

LBG_PANEL* LBG_manage_panel (LBG_PANEL* pan)
{
	LBG_object_upate_pos(pan);
	LBG_object_upate_size(pan);
	LBG_update_panel_layer(pan);
	
	
	if(pan->flags & PF_SHOW)
	{
		pan->panel->flags |= SHOW;
	}
	else
	{
		pan->panel->flags &= ~SHOW;
	}
	
	return pan->next;
}



void LBG_update_panel (LBG_PANEL* pan)
{
	LBG_object_upate_pos(pan);
	LBG_object_upate_size(pan);
	LBG_update_panel_layer(pan);
}

void LBG_panel_execute (LBG_PANEL* pan, void* func)
{
	if(func != 0)
	{
		LBG_event_object = pan;
		LBG_event_panel = pan;
		LBG_event = func;
		LBG_event();
	}
}


LBG_PANEL* LBG_destroy_panel (LBG_PANEL* pan)
{
	LBG_panel_execute(pan,pan->Destroy);
	
	if(pan->flags & PF_HIDE) pan->panel->flags &= ~SHOW;
	if(!(pan->flags & PF_DONTDESTROYPANEL)) ptr_remove(pan->panel);
	
	LBG_object_destroy_infoboxes(pan);
	LBG_object_destroy_rightclicks(pan);
	
	LBG_PANEL* next = pan->next;
	if(pan->previous) pan->previous->next = pan->next;
	else LBG_PANEL_FIRST = pan->next;
	if(pan->next) pan->next->previous = pan->previous;
	
	free(pan);
	LBG_object_make_handles_invalid(pan);
	return(next);
}
