LBG_RIGHTCLICK* LBG_create_rightclick (LBG_WINDOW* _target, var size_x, var ipos_x, var ipos_y, var isize_x, LBG_LISTBOX_BMAPS* bmaps, long flags)
{
	LBG_RIGHTCLICK* rcl = malloc(sizeof(LBG_RIGHTCLICK));
	rcl->ssize = sizeof(LBG_RIGHTCLICK);
	rcl->stype = 15;
	
	
	
	rcl->target = _target;
	rcl->layer = 0;
	rcl->flags = flags;
	
	
	rcl->pos_x = 0;
	rcl->pos_y = 0;
	
	
	
	rcl->scale_x = 1;
	rcl->scale_y = 1;
	
	
	
	rcl->menu = LBG_create_listbox (rcl,0,0,size_x,ipos_y,ipos_x,ipos_y,isize_x,ipos_y,bmaps,0);
	rcl->menu->flags |= LFi_RIGHTCLICK;
	
	
	rcl->next = NULL;
	if(LBG_RIGHTCLICK_FIRST == NULL)
	{
		LBG_RIGHTCLICK_FIRST = rcl;
		rcl->previous = NULL;
	}
	else
	{
		rcl->previous = LBG_object_last(LBG_RIGHTCLICK_FIRST);
		rcl->previous->next = rcl;
	}
	
	rcl->Open = 0;
	rcl->Destroy = 0;
	rcl->Condition = 0;
	
	
	
	return (rcl);
}



void LBG_menu_correct_position (LBG_LISTBOX* mnu)
{
	if(mnu->pos_x < LBG_screenpos_x) mnu->pos_x = 0;
	else if(mnu->pos_x > LBG_screenpos_x + LBG_screensize_x - mnu->size_x) mnu->pos_x = LBG_screenpos_x + LBG_screensize_x - mnu->size_x;
	if(mnu->pos_y < LBG_screenpos_y) mnu->pos_y = 0;
	else if(mnu->pos_y > LBG_screenpos_y + LBG_screensize_y - mnu->size_y) mnu->pos_y = LBG_screenpos_y + LBG_screensize_y - mnu->size_y;
}




void LBG_rightclick_execute (LBG_RIGHTCLICK* rcl, void* func)
{
	if(func != 0)
	{
		LBG_event_object = rcl;
		LBG_event_rightclick = rcl;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_rightclick_condition (LBG_RIGHTCLICK* rcl, void* func)
{
	if(func != 0)
	{
		LBG_event_object = rcl;
		LBG_event_rightclick = rcl;
		LBG_condition = func;
		return LBG_condition();
	}
	return 1;
}

void LBG_rightclick_event (LBG_RIGHTCLICK* rcl)
{
	rcl.flags &= ~RF_EVENT;
	if(!key_pressed(281)) return;
	wait(1);
	if(!key_pressed(281))
	{
		LBG_rightclick_execute(rcl,rcl->Open);
		rcl->flags |= RF_EVENT;
		if(rcl->flags & RF_SHOW) rcl->menu->flags |= LF_SHOW;
		rcl->menu->flags &= ~LF_DISABLED;
		rcl->menu->pos_x = mouse_pos.x;
		rcl->menu->pos_y = mouse_pos.y;
		LBG_listbox_calc_size_y(rcl->menu);
		LBG_menu_correct_position(rcl->menu);
		LBG_update_listbox(rcl->menu);
		wait(1);
		rcl->flags &= ~RF_EVENT;
	}
}




int LBG_rightclick_over_condition (LBG_RIGHTCLICK* rcl)
{
	if (rcl->target) return  (LBG_mouse_over_object(rcl->target) && (rcl->target->parent == LBG_mouse_window()) && LBG_window_mouse_over_content (rcl->target->parent) && ((rcl->target->stype != 2) || ((rcl->target->flags & BFi_OVER))));
	return (!LBG_mouse_window());
}

LBG_RIGHTCLICK* LBG_manage_rightclick (LBG_RIGHTCLICK* rcl)
{
	
	if((rcl->menu->flags & LF_SHOW) && (!(LBG_mouse_over_object(rcl->menu))) && ((key_pressed(280)) || (key_pressed(281))) && (!(rcl->flags & RF_EVENT)))
	{
		rcl->menu->flags &= ~LF_SHOW;
		rcl->menu->flags |= LF_DISABLED;
	}
	
	
	if (!(rcl->flags & RF_DISABLED))
	{
		if (!(key_pressed(280)))
		{
			rcl->flags &= ~RFi_CLICK0;
			rcl->flags &= ~RFi_CLICK1;
			rcl->flags &= ~RF_CLICKED;
		}
		
		if(LBG_rightclick_condition(rcl,rcl->Condition) && LBG_rightclick_over_condition(rcl))
		{
			rcl->flags |= RFi_OVER;
			if (key_pressed(281))
			{
				rcl->flags &= ~RFi_CLICK0;
				rcl->flags |= RFi_CLICK1;
				rcl->flags |= RF_CLICKED;
				
				LBG_rightclick_event(rcl);
				
				rcl->flags |= RF_ACTIVE;
				
			}
		}
		else
		{
			rcl.flags &= ~RF_EVENT;
			
			rcl->flags &= ~RFi_OVER;
			rcl->flags &= ~RF_CLICKED;
		}
		if ((!(rcl->flags & RFi_CLICK0)) && (!(rcl->flags & RFi_CLICK1)) && ((key_pressed(280)) || (key_pressed(281))))
		{
			rcl->flags |= RFi_CLICK0;
			rcl->flags &= ~RFi_CLICK1;
			rcl->flags &= ~RF_CLICKED;
			
			rcl->flags &= ~RF_ACTIVE;
			
		}
		
	}
	else
	{
		rcl->flags |= RFi_CLICK0;
		rcl->flags &= ~RFi_CLICK1;
		rcl->flags &= ~RFi_OVER;
		rcl->flags &= ~RF_CLICKED;
	}
	
	
	
	return rcl->next;
}


void LBG_update_rightclick (LBG_RIGHTCLICK* rcl)
{
	rcl->menu->isize_y = LBG_object_num(rcl->menu->item_first)*rcl->menu->itemheight;
	LBG_update_listbox(rcl->menu);
}

LBG_LISTITEM* LBG_rightclick_add_option (LBG_RIGHTCLICK* rcl, var position, STRING* caption, long flags, void* Event)
{
	LBG_LISTITEM* itm = LBG_create_listitem (rcl->menu,position,caption,flags);
	itm->Select = Event;
	return(itm);
}

LBG_RIGHTCLICK* LBG_destroy_rightclick (LBG_RIGHTCLICK* rcl)
{
	LBG_rightclick_execute(rcl,rcl->Destroy);
	
	LBG_destroy_listbox(rcl->menu);
	
	LBG_object_destroy_infoboxes(rcl);
	LBG_object_destroy_rightclicks(rcl);
	
	LBG_RIGHTCLICK* next = rcl->next;
	if(rcl->previous) rcl->previous->next = rcl->next;
	else LBG_RIGHTCLICK_FIRST = rcl->next;
	if(rcl->next) rcl->next->previous = rcl->previous;
	
	free(rcl);
	LBG_object_make_handles_invalid(rcl);
	return(next);
}