LBG_TEXT* LBG_create_text (LBG_WINDOW* _parent, var pos_x, var pos_y, TEXT* text, long flags)
{
	LBG_TEXT* txt = malloc(sizeof(LBG_TEXT));
	txt->ssize = sizeof(LBG_TEXT);
	txt->stype = 4;
	
	txt->parent = _parent;
	txt->layer = 0;
	txt->flags = flags;
	
	
	txt->pos_x = pos_x;
	txt->pos_y = pos_y;
	
	txt->scale_x = 1;
	txt->scale_y = 1;
	
	txt->text = text;
	
	txt->size_x = txt->text->size_x;
	txt->size_y = txt->text->size_y;
	
	
	txt->text->pos_x = txt->pos_x;
	txt->text->pos_y = txt->pos_y;
	
	if(txt->flags & TF_SHOW)
	{
		if(txt->text) txt->text.flags |= SHOW;
	}
	
	
	txt->Destroy = 0;
	
	
	txt->next = NULL;
	if(LBG_TEXT_FIRST == NULL)
	{
		LBG_TEXT_FIRST = txt;
		txt->previous = NULL;
	}
	else
	{
		txt->previous = LBG_object_last(LBG_TEXT_FIRST);
		txt->previous->next = txt;
	}
	
	return (txt);
}




void LBG_update_text_layer (LBG_TEXT* txt)
{
	var x;
	x = LBG_object_calc_text_layer(txt);
	if(txt->text->layer != x) layer_sort(txt->text,x);
}

LBG_PANEL* LBG_manage_text (LBG_TEXT* txt)
{
	LBG_object_upate_pos(txt);
	LBG_object_upate_size(txt);
	LBG_update_text_layer(txt);
	
	if(txt->flags & TF_SHOW)
	{
		txt->text->flags |= SHOW;
	}
	else
	{
		txt->text->flags &= ~SHOW;
	}
	
	return txt->next;
}



void LBG_update_text (LBG_TEXT* txt)
{
	LBG_object_upate_pos(txt);
	LBG_object_upate_size(txt);
	LBG_update_text_layer(txt);
}

void LBG_text_execute (LBG_TEXT* txt, void* func)
{
	if(func != 0)
	{
		LBG_event_object = txt;
		LBG_event_text = txt;
		LBG_event = func;
		LBG_event();
	}
}



LBG_TEXT* LBG_destroy_text (LBG_TEXT* txt)
{
	LBG_text_execute(txt,txt->Destroy);
	
	if(txt->flags & TF_HIDE) txt->text->flags &= ~SHOW;
	if(!(txt->flags & TF_DONTDESTROYTEXT)) ptr_remove(txt->text);
	
	LBG_object_destroy_infoboxes(txt);
	LBG_object_destroy_rightclicks(txt);
	
	LBG_TEXT* next = txt->next;
	if(txt->previous) txt->previous->next = txt->next;
	else LBG_TEXT_FIRST = txt->next;
	if(txt->next) txt->next->previous = txt->previous;
	
	free(txt);
	LBG_object_make_handles_invalid(txt);
	return(next);
}
