void LBG_vscrollbar_bitmap (BMAP* _bmap, LBG_VSCROLLBAR_BMAPS* bmaps, var size_x, var size_y) // For internal use
{
	bmap_blit(_bmap,bmaps->bmap_top,vector(0,0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_bottom,vector(0,size_y-bmap_height(bmaps->bmap_bottom),0),NULL);
	bmap_blit(_bmap,bmaps->bmap_middle,vector(0,bmap_height(bmaps->bmap_top),0),vector(bmap_width(bmaps->bmap_middle),size_y-bmap_height(bmaps->bmap_top)-bmap_height(bmaps->bmap_bottom),0));
}



void LBG_update_window (LBG_WINDOW* win);
LBG_VSCROLLBAR* LBG_create_vscrollbar (LBG_WINDOW* _target, LBG_VSCROLLBAR_BMAPS* bmaps, LBG_BUTTON_BMAPS* btbmaps, LBG_BUTTON_BMAPS* bbbmaps, long flags)
{
	LBG_VSCROLLBAR* vsb = malloc(sizeof(LBG_VSCROLLBAR));
	vsb->ssize = sizeof(LBG_VSCROLLBAR);
	vsb->stype = 10;
	
	
	
	
	vsb->target = _target;
	vsb->layer = 0;
	vsb->flags = flags;
	
	
	
	vsb->scale_x = 1;
	vsb->scale_y = 1;
	
	vsb->panel = pan_create("",LBG_object_calc_panel_layer(vsb));
	vsb->bmaps.bmap_top = bmaps->bmap_top;
	vsb->bmaps.bmap_middle = bmaps->bmap_middle;
	vsb->bmaps.bmap_bottom = bmaps->bmap_bottom;
	vsb->bmaps.bmap_bar = bmaps->bmap_bar;
	
	
	vsb->panel->bmap = vsb->bmaps.bmap_bar;
	
	
	if(vsb->target)
	switch(vsb->target->stype)
	{
		case 1:
		vsb->ppa = 0.2;
		vsb->wheelspeed = 5;
		break;
		
		case 13:
		vsb->ppa = ((LBG_LISTBOX*)(vsb->target))->itemheight/2;
		vsb->wheelspeed = 0.5;
		break;
		
		default:
		vsb->ppa = 1;
		vsb->wheelspeed = 1;
		break;
	}
	
	
	vsb->size_x = bmap_width(vsb->bmaps.bmap_bar);
	vsb->size_y = 32;
	vsb->scrollbar = pan_create("",LBG_object_calc_panel_layer(vsb)+1);
	vsb->scrollbar->bmap = bmap_createblack(vsb->size_x,vsb->size_y,32);
	LBG_vscrollbar_bitmap(vsb->scrollbar->bmap,bmaps,vsb->size_x,vsb->size_y);
	
	vsb->corner = pan_create("",LBG_object_calc_panel_layer(vsb)+1);
	
	
	
	
	
	vsb->button_top = LBG_create_button(vsb,0,0,0,0,"",btbmaps,0,BF_SHOW | BFi_SCROLLBAR);
	vsb->button_bottom = LBG_create_button(vsb,0,0,0,0,"",bbbmaps,0,BF_SHOW | BFi_SCROLLBAR);
	
	
	
	if(vsb->flags & PBF_SHOW)
	{
		vsb->panel->flags |= SHOW;
		vsb->scrollbar->flags |= SHOW;
		vsb->button_top->flags |= BF_SHOW;
		vsb->button_bottom->flags |= BF_SHOW;
	}
	
	
	vsb->scrollamount = 0;
	vsb->scrollmax = 0;
	vsb->buttonspeed = 5;
	
	
	
	vsb->next = NULL;
	if(LBG_VSCROLLBAR_FIRST == NULL)
	{
		LBG_VSCROLLBAR_FIRST = vsb;
		vsb->previous = NULL;
	}
	else
	{
		vsb->previous = LBG_object_last(LBG_VSCROLLBAR_FIRST);
		vsb->previous->next = vsb;
	}
	
	
	LBG_object_upate_size (vsb);
	
	switch(vsb->target->stype)
	{
		case 1:
		vsb->target->flags |= WF_VSCROLLBAR;
		LBG_update_window(vsb->target);
		break;
		
		case 13:
		vsb->target->flags |= WF_VSCROLLBAR;
		break;
	}
	
	
	vsb->Destroy = 0;
	vsb->Scrolling = 0;
	vsb->Condition = 0;
	
	
	
	return (vsb);
}


void LBG_update_vscrollbar_layer (LBG_VSCROLLBAR* vsb)
{
	var x;
	x = LBG_object_calc_panel_layer(vsb);
	if(vsb->panel->layer != x) layer_sort(vsb->panel,x);
	x = LBG_object_calc_panel_layer(vsb)+1;
	if(vsb->scrollbar->layer != x) layer_sort(vsb->scrollbar,x);
	x = LBG_object_calc_panel_layer(vsb);
	if(vsb->corner->layer != x) layer_sort(vsb->corner,x);
	LBG_update_button_layer (vsb->button_top);
	LBG_update_button_layer (vsb->button_bottom);
}



var LBG_vscrollbar_get_minheight(LBG_VSCROLLBAR* vsb)
{
	return(bmap_height(vsb->bmaps.bmap_top) + bmap_height(vsb->bmaps.bmap_middle) + bmap_height(vsb->bmaps.bmap_bottom));
}
var LBG_vscrollbar_get_maxheight(LBG_VSCROLLBAR* vsb)
{
	return(vsb->size_y - vsb->button_top->size_y - vsb->button_bottom->size_y);
}


void LBG_vscrollbar_calc_barheight(LBG_VSCROLLBAR* vsb)
{
	vsb->scrollbar->size_y = integer(maxv(LBG_vscrollbar_get_minheight(vsb),LBG_vscrollbar_get_maxheight(vsb) - vsb->scrollmax*vsb->ppa)+0.5);
}


int LBG_mouse_over_vscrollbar_move(LBG_VSCROLLBAR* vsb)
{
	switch(vsb->target->stype)
	{
		case 1:
		if(vsb) return ((mouse_pos.x >= vsb->scrollbar->pos_x) && (mouse_pos.x < vsb->scrollbar->pos_x + vsb->scrollbar->size_x) && (mouse_pos.y >= vsb->scrollbar->pos_y) && (mouse_pos.y < vsb->scrollbar->pos_y + vsb->scrollbar->size_y) && (LBG_mouse_window() == vsb->target));
		else return 0;
		break;
		
		case 13:
		if(vsb) return ((mouse_pos.x >= vsb->scrollbar->pos_x) && (mouse_pos.x < vsb->scrollbar->pos_x + vsb->scrollbar->size_x) && (mouse_pos.y >= vsb->scrollbar->pos_y) && (mouse_pos.y < vsb->scrollbar->pos_y + vsb->scrollbar->size_y) && (LBG_mouse_window() == vsb->target->parent));
		else return 0;
		break;
	}
	
}

void LBG_vscrollbar_execute (LBG_VSCROLLBAR* vsb, void* func)
{
	if(func != 0)
	{
		LBG_event_object = vsb;
		LBG_event_scrollbar = vsb;
		LBG_event_vscrollbar = vsb;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_vscrollbar_condition (LBG_VSCROLLBAR* vsb, void* func)
{
	if(func != 0)
	{
		LBG_event_object = vsb;
		LBG_event_scrollbar = vsb;
		LBG_event_vscrollbar = vsb;
		LBG_condition = func;
		return LBG_condition();
	}
	return 1;
}

LBG_WINDOW* LBG_vscrollbar_parent_window(LBG_VSCROLLBAR* vsb)
{
	LBG_WINDOW* p = vsb->target;
	while(p)
	{
		if(p->stype == 2) break;
		p = p->parent;
	}
	return p;
}


int LBG_mouse_over_listbox_larea (LBG_LISTBOX* lst);
int LBG_vscrollbar_mouse_for_wheel (LBG_VSCROLLBAR* vsb)
{
	if(vsb->target)
	switch(vsb->target->stype)
	{
		case 1:
		if(!LBG_scrollbar_no_other(vsb)) return 0;
		return(LBG_window_mouse_over_content(vsb->target) && (LBG_mouse_window() == vsb->target)&& LBG_vscrollbar_condition(vsb,vsb->Condition));
		break;
		case 13:
		return(LBG_window_mouse_over_content(vsb->target->parent) && (LBG_mouse_window() == vsb->target->parent) && LBG_mouse_over_listbox_larea(vsb->target) && LBG_vscrollbar_condition(vsb,vsb->Condition));
		break;
		default: return 0;
	}
}


LBG_VSCROLLBAR* LBG_manage_vscrollbar (LBG_VSCROLLBAR* vsb)
{
	LBG_update_vscrollbar_layer(vsb);
	
	
	
	
	if ((!((vsb->flags & VSF_DISABLED) || (vsb->flags & VSF_AUTODISABLED))) && (vsb->target->flags & WF_VSCROLLBAR) && LBG_not_disabled_by_disableflag(vsb))
	{
		
		if (!(key_pressed(280)))
		{
			vsb->flags &= ~VSFi_CLICK0;
			vsb->flags &= ~VSFi_CLICK1;
		}
		if (LBG_mouse_over_vscrollbar_move(vsb) && (((!(vsb->flags & VSFi_CLICK0)) && (!(vsb->flags & VSFi_CLICK1))) || ((!(vsb->flags & VSFi_CLICK0)) && ((vsb->flags & VSFi_CLICK1)))))
		{
			vsb->flags |= VSFi_OVER;
			if (key_pressed(280))
			{
				if(!((!(vsb->flags & VSFi_CLICK0)) && ((vsb->flags & VSFi_CLICK1))))
				{
					vsb->mg = mouse_pos.y - vsb->scrollbar->pos_y;
				}
				
				vsb->flags &= ~VSFi_CLICK0;
				vsb->flags |= VSFi_CLICK1;
			}
		}
		else
		{
			if(!(vsb->flags & VSFi_OVER))
			{
				vsb->flags &= ~VSFi_OVER;
			}
		}
		if ((!(vsb->flags & VSFi_CLICK0)) && ((vsb->flags & VSFi_CLICK1)))
		{
			vsb->scrollbar->pos_y = mouse_pos.y - vsb->mg;
			LBG_vscrollbar_execute(vsb,vsb->Scrolling);
			
			if (LBG_vscrollbar_get_maxheight(vsb) - vsb->scrollbar->size_y) vsb->scrollamount = (vsb->scrollbar->pos_y - vsb->pos_y - vsb->button_top->size_y)*vsb->scrollmax/(LBG_vscrollbar_get_maxheight(vsb) - vsb->scrollbar->size_y);
			else vsb->scrollamount = 0;
		}
		if ((!(vsb->flags & VSFi_CLICK0)) && (!(vsb->flags & VSFi_CLICK1)) && (key_pressed(280)))
		{
			vsb->flags |= VSFi_CLICK0;
			vsb->flags &= ~VSFi_CLICK1;
		}
		
	}
	
	
	
	if(vsb->target)
	switch(vsb->target->stype)
	{
		case 1:
		vsb->pos_x = vsb->target->cpos_x + vsb->target->csize_x;
		vsb->pos_y = vsb->target->cpos_y;
		vsb->size_y = vsb->target->csize_y;
		
		vsb->panel->pos_x = vsb->pos_x;
		vsb->panel->pos_y = vsb->pos_y;
		vsb->panel->size_y = vsb->size_y;
		
		vsb->button_bottom->pos_y = vsb->size_y - vsb->button_bottom->size_y;
		
		
		vsb->scrollbar->pos_x = vsb->pos_x;
		vsb->scrollbar->pos_y = vsb->pos_y + vsb->button_top->size_y;
		
		vsb->corner->pos_x = vsb->pos_x;
		
		
		break;
		
		
		case 13:
		vsb->pos_x = LBG_object_realpos_x(vsb->target) + ((LBG_LISTBOX*)(vsb->target))->size_x - vsb->size_x;
		vsb->pos_y = LBG_object_realpos_y(vsb->target);
		vsb->size_y = ((LBG_LISTBOX*)(vsb->target))->size_y;
		
		vsb->panel->pos_x = vsb->pos_x;
		vsb->panel->pos_y = vsb->pos_y;
		vsb->panel->size_y = vsb->size_y;
		
		vsb->button_bottom->pos_y = vsb->size_y - vsb->button_bottom->size_y;
		
		
		vsb->scrollbar->pos_x = vsb->pos_x;
		vsb->scrollbar->pos_y = vsb->pos_y + vsb->button_top->size_y;
		
		vsb->corner->pos_x = vsb->pos_x;
		
		
		
		
		
		break;
	}
	
	
	LBG_vscrollbar_calc_barheight(vsb);
	if(vsb->scrollbar->size_y != bmap_height(vsb->scrollbar->bmap))
	{
		ptr_remove(vsb->scrollbar->bmap);
		vsb->scrollbar->bmap = bmap_createblack(vsb->size_x,vsb->scrollbar->size_y,32);
		LBG_vscrollbar_bitmap(vsb->scrollbar->bmap,vsb->bmaps,vsb->size_x,vsb->scrollbar->size_y);
	}
	
	if((vsb->button_top->flags & BF_CLICKED) && LBG_mouse_over_object(vsb->button_top))
	{
		vsb->scrollamount -= vsb->buttonspeed*time_step;
		LBG_vscrollbar_execute(vsb,vsb->Scrolling);
	}
	if((vsb->button_bottom->flags & BF_CLICKED) && LBG_mouse_over_object(vsb->button_bottom))
	{
		vsb->scrollamount += vsb->buttonspeed*time_step;
		LBG_vscrollbar_execute(vsb,vsb->Scrolling);
	}
	
	if(LBG_vscrollbar_mouse_for_wheel(vsb) && LBG_not_disabled_by_disableflag(vsb)) vsb->scrollamount -= vsb->wheelspeed*mickey.z/12;
	if(LBG_vscrollbar_mouse_for_wheel(vsb) && LBG_not_disabled_by_disableflag(vsb) && vsb->wheelspeed*mickey.z) LBG_hscrollbar_execute(vsb,vsb->Scrolling);
	
	vsb->scrollamount = minv(vsb->scrollamount,vsb->scrollmax);
	vsb->scrollamount = maxv(vsb->scrollamount,0);
	if(vsb->scrollmax) vsb->scrollbar->pos_y += (LBG_vscrollbar_get_maxheight(vsb)-vsb->scrollbar->size_y)*vsb->scrollamount/vsb->scrollmax;
	
	if(vsb->target)
	switch(vsb->target->stype)
	{
		case 1: vsb->target->vscrollamount = vsb->scrollamount; break;
		case 13: ((LBG_LISTBOX*)(vsb->target))->vscrollamount = vsb->scrollamount; break;
		
	}
	
	
	
	vsb->corner->flags &= ~SHOW;
	
	
	if(vsb->flags & VSF_SHOW)
	{
		vsb->panel->flags |= SHOW;
		vsb->scrollbar->flags |= SHOW;
		vsb->button_top->flags |= BF_SHOW;
		vsb->button_bottom->flags |= BF_SHOW;
	}
	else
	{
		vsb->panel->flags &= ~SHOW;
		vsb->scrollbar->flags &= ~SHOW;
		vsb->corner->flags &= ~SHOW;
		vsb->button_top->flags &= ~BF_SHOW;
		vsb->button_bottom->flags &= ~BF_SHOW;
	}
	
	if((vsb->flags & VSF_AUTODISABLED) || (!(vsb->target->flags & WF_VSCROLLBAR)))
	{
		vsb->panel->flags &= ~SHOW;
		vsb->scrollbar->flags &= ~SHOW;
		vsb->corner->flags &= ~SHOW;
		vsb->button_top->flags &= ~BF_SHOW;
		vsb->button_bottom->flags &= ~BF_SHOW;
	}
	
	if(vsb->target) if(vsb->target->stype == 13)
	{
		vsb->panel->size_x = maxv(0.1,minv(bmap_width(vsb->panel->bmap),((LBG_LISTBOX*)(vsb->target))->panel->pos_x+((LBG_LISTBOX*)(vsb->target))->panel->size_x-vsb->panel->pos_x)+0.1);
		vsb->panel->size_y = maxv(0.1,minv(vsb->size_y,((LBG_LISTBOX*)(vsb->target))->panel->pos_y+((LBG_LISTBOX*)(vsb->target))->panel->size_y-vsb->panel->pos_y)+0.1);
		
		vsb->scrollbar->size_x = vsb->panel->size_x;
		vsb->scrollbar->size_y = maxv(0.1,minv(vsb->scrollbar->size_y,((LBG_LISTBOX*)(vsb->target))->panel->pos_y+((LBG_LISTBOX*)(vsb->target))->panel->size_y-vsb->scrollbar->pos_y)+0.1);
	}
	
	return(vsb->next);
}



void LBG_vsbmaps_destroy_2frames (LBG_VSCROLLBAR_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_VSCROLLBAR_BMAPS* LBG_vsbmaps (BMAP* bmap_top, BMAP* bmap_middle, BMAP* bmap_bottom, BMAP* bmap_bar)
{
	LBG_VSCROLLBAR_BMAPS* bmaps = malloc(sizeof(LBG_VSCROLLBAR_BMAPS));
	bmaps->bmap_top = bmap_top;
	bmaps->bmap_middle = bmap_middle;
	bmaps->bmap_bottom = bmap_bottom;
	bmaps->bmap_bar = bmap_bar;
	LBG_pbmaps_destroy_2frames(bmaps);
	return(bmaps);
}



LBG_VSCROLLBAR* LBG_destroy_vscrollbar (LBG_VSCROLLBAR* vsb)
{
	LBG_vscrollbar_execute(vsb,vsb->Destroy);
	
	ptr_remove(vsb->panel);
	ptr_remove(vsb->scrollbar);
	ptr_remove(vsb->corner);
	LBG_destroy_button(vsb->button_top);
	LBG_destroy_button(vsb->button_bottom);
	
	LBG_object_destroy_infoboxes(vsb);
	LBG_object_destroy_rightclicks(vsb);
	
	LBG_VSCROLLBAR* next = vsb->next;
	if(vsb->previous) vsb->previous->next = vsb->next;
	else LBG_VSCROLLBAR_FIRST = vsb->next;
	if(vsb->next) vsb->next->previous = vsb->previous;
	
	free(vsb);
	LBG_object_make_handles_invalid(vsb);
	return(next);
}